/*********************************************************************************
*                                                                                *
*    GME2BIN - Sony Pocketstation Rom Converter by p0p / Team POKeMe in 2006     *
*                     visit us @ http://pokeme.shizzle.it                        *
*                                                                                *
*********************************************************************************/


#include "stdafx.h"
#define romsize 0x20f40

char *inputfile;
char *outputfile;
FILE *fi;
FILE *fo;


unsigned char infile[romsize];
unsigned char outfile[romsize];




void help()
{
	printf("\ngme2bin v1.0 by p0p for Team POKeMe * SONY PocketStation rom tool\n\nusage: gme2bin.exe infile.gme outfile.bin\n");
}


void error(char text[])
{
	fprintf(stderr, "\n**ERROR: %s\n",text);
}




int main(int argc, char *argv[])
{

// handle parameters
	
	for (int a=1; a<argc; a++)
	{
		if (!inputfile)
			inputfile = argv[a];
		else if (!outputfile)
			outputfile = argv[a];
			else
			{
				error("Too many arguments");
				return(-1);
			}	
	}


	if (!inputfile)
	{
		help();
		return 0;
	}

	if (!outputfile)
	{
		help();
		return -1;
	}



// read original rom
	
	fi = fopen(inputfile, "rb");
	if (!fi)
	{
		error("Input file not valid");
		return -1;
	}

	fseek(fi, 0, SEEK_END);

	if (int (ftell(fi))!=romsize)
		fprintf(stderr, "\nWARNING: Not a valid Pocket MuuMuu rom file");


	fseek(fi, 0, SEEK_SET);
	fread (infile, 1, romsize, fi);
	fclose(fi);





// do conversion


	int i=romsize-1;

	while (!infile[i])
		i--;

	
	int ende = i+1;

	while ( infile[i] != 0x30  || infile[i-1] != 0x58 || infile[i-2] != 0x43  || infile[i-3] != 0x4d )
	{
		i--;
		if ( i <= 0 )
		{
			error("Not a valid rom file");
			return -1;
		}
	}


	int anf = i-85;

	for(int x=anf ; x<ende; x++)
		outfile[x-anf] = infile[x];

	
	int size = ende-anf;
	int mist = size%16;

	if (mist != 0)
		size = size+(16-mist);




// write outputfile


	fo = fopen(outputfile, "wb");
	
	if (!fo)
	{
		error("Output file write failure");
		return -1;
	}

	fwrite(outfile, 1, size, fo);
	fclose(fo);

	printf("\nFile successfully written (%d bytes)\n",size);


	return 0;
}




